#include "matrix.h"

MMatrix::MMatrix():_data(0)
{
}

MMatrix::MMatrix( int nRows, int nCols ):_data(0)
{
  Allocate( nRows, nCols );
}


int MMatrix::Allocate( int nRows, int nCols )
{
  if( _data )
  {
    for( int i=0;i<_nRows;i++ ) delete[] _data[i];
    delete[] _data;
  }
  
  _nRows=nRows;
  _nCols=nCols;
  _data=new float*[nRows];
  if( !_data ) return -1;
  
  for( int i=0;i<nRows;i++ )
  {
    _data[i]=new float[nCols];
    
    if( !_data[i] )
    {
      for( int j=0;j<i;j++ )
      {
        delete[] _data[j];
      }
      delete[] _data;
    }
  }
}


void MMatrix::Set( int row, int col, float value )
{
  _data[row][col]=value;
}

float MMatrix::Get( int row, int col )
{
  return _data[row][col];
}


MMatrix::~MMatrix()
{
  if( _data )
  {
    for( int i=0;i<_nRows;i++ ) delete[] _data[i];
    delete[] _data;
  }
}
