#include "particle.h"




PParticle::PParticle() : _x(NULL), _v(NULL), _pbestx(NULL)
{
  SetDimension();
}

int PParticle::SetDimension( int d )
{
  // housework
  if( _x )
  {
    delete[] _x;
    _x=NULL;
  }
  if( _v )
  {
    delete[] _v;
    _v=NULL;
  }
  if( _pbestx )
  {
    delete[] _pbestx;
    _pbestx=NULL;
  }
  
  // allocate memory
  _x=new float[d];
  _v=new float[d];
  _pbestx=new float[d];
  
  // housework
  if( !_x || !_v || !_pbestx )
  {
    if( _x ) delete[] _x;
    if( _v ) delete[] _v;
    if( _pbestx ) delete[] _pbestx;
    
    _x=_v=_pbestx=NULL;
    return -1;
  }
  
  // setting dimension
  _dimension=d;
  
  return 0; // all fine
}

void PParticle::SetX( float x, int d )
{
  if( d<_dimension ) _x[d]=x;
}

void PParticle::SetV( float v, int d )
{
  if( d<_dimension ) _v[d]=v;
}

void PParticle::SetPbest( float best )
{
  _pbest=best;
}

void PParticle::SetPbestx( float x, int d )
{
  if( d<_dimension ) _pbestx[d]=x;
}




int PParticle::GetDimension()
{
  return _dimension;
}

float PParticle::GetX( int d )
{
  if( d<_dimension ) return _x[d];
  return 0.0f;
}

float PParticle::GetV( int d )
{
  if( d<_dimension ) return _v[d];
  return 0.0f;
}

float PParticle::GetPbest()
{
  return _pbest;
}

float PParticle::GetPbestx( int d )
{
  if( d<_dimension ) return _pbestx[d];
  return 0.0f;
}






PParticle::~PParticle()
{
  if( _x ) delete[] _x;
  if( _v ) delete[] _v;
  if( _pbestx ) delete[] _pbestx;
}
